## gemrb 0.7.1maemo1

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 2.6.0)
if(COMMAND cmake_policy)
	cmake_policy(SET CMP0003 NEW)
	cmake_policy(SET CMP0005 NEW)
endif(COMMAND cmake_policy)

# prevent in-source builds
IF(NOT INSOURCEBUILD AND (${CMAKE_SOURCE_DIR} STREQUAL ${CMAKE_BINARY_DIR}))
	MESSAGE(FATAL_ERROR "
		CMake generation for this project is not allowed within the source directory!
		Remove the CMake cache files and try again from another folder, e.g.:
		  rm -r CMakeCache.txt CMakeFiles/
		  mkdir build
		  cd build
		  cmake ..
		If you really want an in-source build, pass -DINSOURCEBUILD=1"
	)
ENDIF()

# If the user specifies -DCMAKE_BUILD_TYPE on the command line, take their definition
# and dump it in the cache along with proper documentation, otherwise set CMAKE_BUILD_TYPE
# to Release prior to calling PROJECT()
IF(DEFINED CMAKE_BUILD_TYPE)
	SET(CMAKE_BUILD_TYPE ${CMAKE_BUILD_TYPE} CACHE STRING "Choose the type of build, options are: None(CMAKE_CXX_FLAGS or CMAKE_C_FLAGS used) Debug Release RelWithDebInfo MinSizeRel.")
ELSE(DEFINED CMAKE_BUILD_TYPE)
	SET(CMAKE_BUILD_TYPE RelWithDebInfo CACHE STRING "Choose the type of build, options are: None(CMAKE_CXX_FLAGS or CMAKE_C_FLAGS used) Debug Release RelWithDebInfo MinSizeRel.")
ENDIF(DEFINED CMAKE_BUILD_TYPE)

PROJECT(gemrb)
# try to extract the version from the source
execute_process(
	COMMAND sed -n "s/\#define VERSION_GEMRB .\\([^\"]*\\).$/\\1/p" ${CMAKE_CURRENT_SOURCE_DIR}/gemrb/includes/globals.h
	OUTPUT_VARIABLE GEMRB_VERSION
	RESULT_VARIABLE RC
	OUTPUT_STRIP_TRAILING_WHITESPACE
)
if(${RC} GREATER 0) # lookup failed
	set(GEMRB_VERSION "unknown")
endif(${RC} GREATER 0)
message("Detected version: ${GEMRB_VERSION}")

IF(PREFIX)
	SET(PREFIX CACHE PATH "Abbreviation for CMAKE_INSTALL_PREFIX.")
	SET(CMAKE_INSTALL_PREFIX ${PREFIX})
ENDIF(PREFIX)

if (NOT LAYOUT)
	if (WIN32)
		set(LAYOUT "home")
	elseif (APPLE)
		set(LAYOUT "library")
		# favor mac frameworks over unix libraries
		set(CMAKE_FIND_FRAMEWORK FIRST)
	else (APPLE)
		set(LAYOUT "fhs")
	endif (WIN32)
endif (NOT LAYOUT)

SET(LAYOUT "${LAYOUT}" CACHE STRING "Directory layout.")

# macro that sets a default (path) if one wasn't specified
MACRO(SET_PATH variable default)
	IF(NOT ${variable})
		SET(${variable} ${default})
	ENDIF(NOT ${variable})
ENDMACRO(SET_PATH)

if (${LAYOUT} MATCHES "home")
	SET_PATH( PLUGIN_DIR ${CMAKE_INSTALL_PREFIX}/plugins )
	SET_PATH( DATA_DIR ${CMAKE_INSTALL_PREFIX} )
	SET_PATH( MAN_DIR ${CMAKE_INSTALL_PREFIX}/man/man6 )
	SET_PATH( BIN_DIR ${CMAKE_INSTALL_PREFIX} )
	SET_PATH( SYSCONF_DIR ${CMAKE_INSTALL_PREFIX} )
	SET_PATH( LIB_DIR ${CMAKE_INSTALL_PREFIX} )
	SET_PATH( DOC_DIR ${CMAKE_INSTALL_PREFIX}/doc )
	SET_PATH( ICON_DIR ${CMAKE_INSTALL_PREFIX} )
	SET_PATH( SVG_DIR ${CMAKE_INSTALL_PREFIX} )
	SET_PATH( MENU_DIR ${CMAKE_INSTALL_PREFIX} )
elseif (${LAYOUT} MATCHES "fhs")
	SET_PATH( LIB_DIR ${CMAKE_INSTALL_PREFIX}/lib/gemrb )
	SET_PATH( PLUGIN_DIR ${LIB_DIR}/plugins )
	SET_PATH( DATA_DIR ${CMAKE_INSTALL_PREFIX}/share/gemrb )
	SET_PATH( MAN_DIR ${CMAKE_INSTALL_PREFIX}/share/man/man6 )
	SET_PATH( BIN_DIR ${CMAKE_INSTALL_PREFIX}/bin )
	IF( NOT SYSCONF_DIR )
		if ( ${CMAKE_INSTALL_PREFIX} STREQUAL "/usr" )
			SET( SYSCONF_DIR /etc/gemrb )
		else ()
			SET( SYSCONF_DIR ${CMAKE_INSTALL_PREFIX}/etc/gemrb )
		endif ()
	ENDIF( NOT SYSCONF_DIR )
	SET_PATH( DOC_DIR ${CMAKE_INSTALL_PREFIX}/share/doc/gemrb )
	SET_PATH( ICON_DIR ${CMAKE_INSTALL_PREFIX}/share/pixmaps )
	SET_PATH( SVG_DIR ${CMAKE_INSTALL_PREFIX}/share/icons/hicolor/scalable/apps )
	SET_PATH( MENU_DIR ${CMAKE_INSTALL_PREFIX}/share/applications )
elseif (${LAYOUT} MATCHES "opt")
	SET_PATH( LIB_DIR ${CMAKE_INSTALL_PREFIX}/lib )
	SET_PATH( PLUGIN_DIR ${LIB_DIR}/plugins )
	SET_PATH( DATA_DIR ${CMAKE_INSTALL_PREFIX}/share/ )
	SET_PATH( MAN_DIR ${CMAKE_INSTALL_PREFIX}/man/man6 )
	SET_PATH( BIN_DIR ${CMAKE_INSTALL_PREFIX}/bin )
	SET_PATH( SYSCONF_DIR ${CMAKE_INSTALL_PREFIX}/etc )
	SET_PATH( DOC_DIR ${CMAKE_INSTALL_PREFIX}/share/doc/gemrb )
	SET_PATH( ICON_DIR ${CMAKE_INSTALL_PREFIX}/share/pixmaps )
	SET_PATH( SVG_DIR ${CMAKE_INSTALL_PREFIX}/share/icons/hicolor/scalable/apps )
	SET_PATH( MENU_DIR ${CMAKE_INSTALL_PREFIX}/share/applications )
else (${LAYOUT} MATCHES "library") # mac
	SET_PATH( APPLICATION_SUPPORT $ENV{HOME}/Library/Application\ Support/GemRB)
	SET_PATH( LIB_DIR ${APPLICATION_SUPPORT}) #should go in app bundle!
	SET_PATH( PLUGIN_DIR ${APPLICATION_SUPPORT}/plugins )
	SET_PATH( DATA_DIR ${APPLICATION_SUPPORT} )
	SET_PATH( MAN_DIR /usr/share/man/man6 )
	SET_PATH( BIN_DIR /Applications )
	SET_PATH( SYSCONF_DIR ${APPLICATION_SUPPORT})
	SET_PATH( DOC_DIR ${APPLICATION_SUPPORT} )
	SET_PATH( ICON_DIR ${APPLICATION_SUPPORT}/share/pixmaps )
	SET_PATH( SVG_DIR ${APPLICATION_SUPPORT}/share/icons/hicolor/scalable/apps )
	SET_PATH( MENU_DIR ${APPLICATION_SUPPORT}/share/applications )
endif (${LAYOUT} MATCHES "home")

# check if this is a release version
execute_process(
	COMMAND echo ${GEMRB_VERSION}
	COMMAND grep -q git # cmake creates a pipe by itself
	RESULT_VARIABLE RC
	OUTPUT_QUIET
)
if(${RC} GREATER 0) # no match or error
	set (GIT_VERSION 0)
else()
	set (GIT_VERSION 1)
endif()

IF(CMAKE_CXX_COMPILER_ID MATCHES "GNU|Clang")
	if ((NOT DISABLE_WERROR) AND GIT_VERSION)
		set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Werror")
	endif ()
	set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wall -W -Wpointer-arith -Wcast-align")
	set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -pedantic -Wno-format-y2k -Wno-long-long -fno-strict-aliasing")
	# only export symbols explicitly marked to be exported.
	INCLUDE(CheckCXXCompilerFlag)
	CHECK_CXX_COMPILER_FLAG("-fvisibility=hidden" VISIBILITY_HIDDEN)
	IF (VISIBILITY_HIDDEN AND NOT WIN32)
		set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -fvisibility=hidden")
	ENDIF ()
	if (WIN32)
		# GCC 4.5.0+ has shared libstdc++ without dllimport
		set(CMAKE_SHARED_LINKER_FLAGS "${CMAKE_SHARED_LINKER_FLAGS} -Wl,--enable-auto-import")
		set(CMAKE_MODULE_LINKER_FLAGS "${CMAKE_MODULE_LINKER_FLAGS} -Wl,--enable-auto-import")
	endif (WIN32)
	# Ensure all plugin symbols exist.
	if (NOT APPLE AND NOT UNSAFE_PLUGIN)
		set(CMAKE_MODULE_LINKER_FLAGS "${CMAKE_MODULE_LINKER_FLAGS} -Wl,--no-undefined")
	endif (NOT APPLE AND NOT UNSAFE_PLUGIN)
ENDIF()

set(CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} "${CMAKE_CURRENT_SOURCE_DIR}/cmake/modules/")

# Check for all the required and optional dependencies
INCLUDE(FindPythonLibs)
IF(PYTHONLIBS_FOUND)
	MESSAGE(STATUS "Looking for Python libraries and headers: found")
ELSE()
	MESSAGE(SEND_ERROR "Looking for Python libraries and headers: not found!")
	MESSAGE(FATAL_ERROR "Please get them (www.python.org)")
ENDIF()

INCLUDE(FindSDL)
IF(SDL_FOUND)
	MESSAGE(STATUS "Looking for SDL: found")
ELSE()
	MESSAGE(SEND_ERROR "Looking for SDL: not found!")
	MESSAGE(FATAL_ERROR "Please get it from www.libsdl.org")
ENDIF()

INCLUDE(FindZLIB)
IF(ZLIB_FOUND)
	MESSAGE(STATUS "Looking for Zlib: found")
ELSE()
	MESSAGE(SEND_ERROR "Looking for Zlib: not found!")
	MESSAGE(FATAL_ERROR "Please install the Zlib library and headers first!")
ENDIF()

IF(UNIX)
	SET(CMAKE_THREAD_PREFER_PTHREAD true)
	FIND_PACKAGE(Threads REQUIRED)
ENDIF(UNIX)

INCLUDE(FindOpenAL)
IF(OPENAL_FOUND)
	MESSAGE(STATUS "Looking for OpenAL: found")
ELSE()
	MESSAGE(WARNING "Looking for OpenAL: not found!")
	MESSAGE(WARNING "If you want to build the OpenAL plugin, get OpenAL from www.openal.org.")
	MESSAGE(WARNING "If it just wasn't found, try setting the OPENALDIR environment variable.")
ENDIF()

INCLUDE(FindSDL_mixer)
IF(SDLMIXER_FOUND)
	MESSAGE(STATUS "Looking for SDL_mixer: found")
ELSE()
	MESSAGE(WARNING "Looking for SDL_mixer: not found!")
	MESSAGE(WARNING "If you want to build the SDL_mixer plugin, install SDL_mixer first.")
ENDIF()

INCLUDE(FindLIBVLC)
IF(LIBVLC_FOUND)
	MESSAGE(STATUS "Looking for VLC: found")
ELSE()
	MESSAGE(WARNING "Looking for VLC: not found!")
	MESSAGE(WARNING "If you want to build the VLC plugin, install VLC first.")
ENDIF()

INCLUDE(FindSDL_ttf)
IF(SDLTTF_FOUND)
	MESSAGE(STATUS "Looking for SDL_ttf: found")
ELSE()
	MESSAGE(WARNING "Looking for SDL_ttf: not found!")
	MESSAGE(WARNING "If you want to build the SDL_ttf plugin, install SDL_ttf first.")
ENDIF()

INCLUDE(FindPNG)
IF(PNG_FOUND)
	MESSAGE(STATUS "Looking for libPNG: found")
ELSE()
	MESSAGE(WARNING "Looking for libPNG: not found!")
	MESSAGE(WARNING "GemRB will be built without any PNG support. Get it from www.libpng.org" )
	MESSAGE(WARNING "While no original game data is in PNG format, some mod data is and will need conversion.")
ENDIF()

FIND_LIBRARY(VORBIS_LIBRARY vorbisfile)
IF(VORBIS_LIBRARY)
	find_path(VORBIS_FILE vorbisfile.h PATH_SUFFIXES vorbis)
	IF(VORBIS_FILE)
		MESSAGE(STATUS "Looking for Ogg Vorbis support: found")
	ELSE()
		unset(VORBIS_LIBRARY) # disable the build for this plugin
	ENDIF()
ENDIF()
IF(NOT VORBIS_LIBRARY)
	MESSAGE(WARNING "Looking for Ogg Vorbis support: not found!")
	MESSAGE(WARNING "While no original game data is in OGG format, some mod data is and will need conversion.")
ENDIF()

ADD_DEFINITIONS("-DHAVE_CONFIG_H")

# On Release builds cmake automatically defines NDEBUG, so we
# explicitly undefine it:
if(CMAKE_BUILD_TYPE STREQUAL "Release" AND NOT MSVC)
	ADD_DEFINITIONS("-UNDEBUG")
endif()

if (STATIC_LINK)
	if (NOT WIN32)
		ADD_DEFINITIONS("-DSTATIC_LINK")
	else (NOT WIN32)
		unset(STATIC_LINK CACHE)
		MESSAGE(STATUS "Static linking not (yet) supported on this platform.")
	endif (NOT WIN32)
endif (STATIC_LINK)

INCLUDE_DIRECTORIES(${CMAKE_CURRENT_BINARY_DIR} gemrb/includes gemrb/core)

#Platform checks
INCLUDE (CheckTypeSize)
CHECK_TYPE_SIZE("int" SIZEOF_INT)
CHECK_TYPE_SIZE("long int" SIZEOF_LONG_INT)

INCLUDE (CheckFunctionExists)
CHECK_FUNCTION_EXISTS("strndup" HAVE_STRNDUP)

CHECK_INCLUDE_FILES("unistd.h" HAVE_UNISTD_H)
CHECK_INCLUDE_FILES("malloc.h" HAVE_MALLOC_H)

#Unneeded on windows
IF(NOT WIN32)
	INCLUDE (CheckCXXSourceCompiles)
	CHECK_CXX_SOURCE_COMPILES("typedef void *(* voidvoid)(void);

		void *object = 0;
		voidvoid function;
		function = (voidvoid) object;
		" PERMITS_OBJECT_TO_FUNCTION_CAST)

	IF( NOT PERMITS_OBJECT_TO_FUNCTION_CAST )
		SET(HAVE_FORBIDDEN_OBJECT_TO_FUNCTION_CAST 1)
	ENDIF( NOT PERMITS_OBJECT_TO_FUNCTION_CAST )
ENDIF(NOT WIN32)

IF(APPLE)
	ADD_DEFINITIONS("-x objective-c++")
	INCLUDE_DIRECTORIES(apple)
	FIND_LIBRARY(COCOA_LIBRARY_PATH Cocoa)
	# for objective-c++
	SET (CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -DTARGET_OS_MAC")
	# for pure objective-c
	SET (CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -x objective-c -DTARGET_OS_MAC")
ENDIF(APPLE)

IF (MINGW)
	SET (WIN32_USE_STDIO Yes)
ENDIF ()
if (WIN32_USE_STDIO)
	SET (NOCOLOR Yes)
ENDIF()

CONFIGURE_FILE(${CMAKE_CURRENT_SOURCE_DIR}/cmake/cmake_config.h.in
	${CMAKE_CURRENT_BINARY_DIR}/config.h ESCAPE_QUOTES)

#Plugin addition macro
MACRO(ADD_GEMRB_PLUGIN plugin_name)
	SET (PLUGIN_BUILD_FILES ${ARGN})
	if (${ARGV1} STREQUAL "COCOA")
		LIST(REMOVE_ITEM PLUGIN_BUILD_FILES "COCOA")
		#this is an Apple thing
		if (APPLE)
			SET_SOURCE_FILES_PROPERTIES(
				CocoaWrapper.m
				PROPERTIES LANGUAGE C
			)
			message(STATUS "Will link ${plugin_name} plugin to: ${BUNDLE_LOADER}")
			SET (PLUGIN_BUILD_FILES ${PLUGIN_BUILD_FILES} CocoaWrapper.m)
		endif (APPLE)
	endif (${ARGV1} STREQUAL "COCOA")

        if (STATIC_LINK)
                ADD_LIBRARY(${plugin_name} STATIC ${PLUGIN_BUILD_FILES})
                set(plugins "${plugins};${plugin_name}" PARENT_SCOPE)
        else (STATIC_LINK)
                ADD_LIBRARY(${plugin_name} MODULE ${PLUGIN_BUILD_FILES})
                if (NOT UNSAFE_PLUGIN)
                        TARGET_LINK_LIBRARIES(${plugin_name} gemrb_core ${CMAKE_THREAD_LIBS_INIT})
                endif (NOT UNSAFE_PLUGIN)
                INSTALL(TARGETS ${plugin_name} DESTINATION ${PLUGIN_DIR})
        endif (STATIC_LINK)
        SET_TARGET_PROPERTIES(${plugin_name} PROPERTIES PREFIX ""
                INSTALL_RPATH ${LIB_DIR}
                LIBRARY_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR}/gemrb/plugins)
ENDMACRO(ADD_GEMRB_PLUGIN)

#gemrb overrides macro

=== gemrb/CMakeLists.txt ===
ADD_SUBDIRECTORY( core )

IF(APPLE)
	SET_SOURCE_FILES_PROPERTIES(
		../artwork/gemrb.icns
		PROPERTIES MACOSX_PACKAGE_LOCATION Resources
	)
	SET(MACOSX_BUNDLE_ICON_FILE gemrb)
	ADD_EXECUTABLE(gemrb MACOSX_BUNDLE ../apple/CocoaWrapper/mac/CocoaWrapper.mm ../apple/AppleLogger.mm ../artwork/gemrb.icns)
	SET (BUNDLE_LOADER "${CMAKE_CURRENT_BINARY_DIR}/${PROJECT_NAME}.app/Contents/MacOS/${PROJECT_NAME}") # BUNDLE_LOADER is used by plugins needing to extend the cocoa wrapper (SDLVideo).
	SET(CMAKE_MODULE_LINKER_FLAGS "${CMAKE_MODULE_LINKER_FLAGS} -bundle_loader ${BUNDLE_LOADER}")
ELSE(APPLE)
	ADD_EXECUTABLE(gemrb GemRB.cpp )
ENDIF(APPLE)
# we need to add gemrb target before processing plugins or COCOA plugins don't work right.

ADD_SUBDIRECTORY( plugins )
ADD_SUBDIRECTORY( docs )
ADD_SUBDIRECTORY( tests )
IF (APPLE)
	# GUIScripts ALWAYS get copied to the App bundle
	SET( DATA_DIR ${BIN_DIR}/${PROJECT_NAME}.app/Contents/Resources/ )
ENDIF(APPLE)
ADD_SUBDIRECTORY( override )
ADD_SUBDIRECTORY( GUIScripts )

SET_TARGET_PROPERTIES(gemrb PROPERTIES INSTALL_RPATH ${LIB_DIR})
INCLUDE_DIRECTORIES( ${SDL_INCLUDE_DIR} )
IF(WIN32)
 TARGET_LINK_LIBRARIES(gemrb gemrb_core)
ELSE(WIN32)
 IF(APPLE)
	if (STATIC_LINK)
		TARGET_LINK_LIBRARIES(gemrb
			  ${COCOA_LIBRARY_PATH} ${CMAKE_DL_LIBS} ${CMAKE_THREAD_LIBS_INIT}
			 gemrb_core ${plugins}  -Wl,-all_load)
	else (STATIC_LINK)
		TARGET_LINK_LIBRARIES(gemrb gemrb_core
			  ${COCOA_LIBRARY_PATH} ${CMAKE_DL_LIBS} ${CMAKE_THREAD_LIBS_INIT})
	endif (STATIC_LINK)
 ELSE(APPLE)
  if (STATIC_LINK)
	  TARGET_LINK_LIBRARIES(gemrb ${CMAKE_DL_LIBS} ${CMAKE_THREAD_LIBS_INIT}
		  -Wl,--whole-archive gemrb_core ${plugins} -Wl,--no-whole-archive)
  else (STATIC_LINK)
	  TARGET_LINK_LIBRARIES(gemrb gemrb_core ${CMAKE_DL_LIBS} ${CMAKE_THREAD_LIBS_INIT})
  endif (STATIC_LINK)
 ENDIF(APPLE)
ENDIF(WIN32)

# preconfigure the sample config with the selected paths
CONFIGURE_FILE(
  "${CMAKE_CURRENT_SOURCE_DIR}/GemRB.cfg.sample.in"
  "${CMAKE_CURRENT_BINARY_DIR}/GemRB.cfg.sample"
  IMMEDIATE @ONLY
)

INSTALL( TARGETS gemrb DESTINATION ${BIN_DIR} )
INSTALL( FILES "${CMAKE_CURRENT_BINARY_DIR}/GemRB.cfg.sample" GemRB.cfg.noinstall.sample DESTINATION ${SYSCONF_DIR} )

=== gemrb/core/CMakeLists.txt ===
ADD_DEFINITIONS(-DGEM_BUILD_DLL)

IF (ANDROID)
	set (PLATFORM_SRC System/Logger/Android.cpp)
ELSEIF (WIN32)
	set (PLATFORM_SRC System/Logger/Win32Console.cpp)
ELSE ()
	set (PLATFORM_SRC)
ENDIF ()

FILE(GLOB gemrb_core_LIB_SRCS
	ActorMgr.cpp
	Ambient.cpp
	AmbientMgr.cpp
	Animation.cpp
	AnimationFactory.cpp
	AnimationMgr.cpp
	ArchiveImporter.cpp
	Audio.cpp
	Bitmap.cpp
	Cache.cpp
	Calendar.cpp
	Callback.cpp
	CharAnimations.cpp
	Compressor.cpp
	ControlAnimation.cpp
	Core.cpp
	DataFileMgr.cpp
	Dialog.cpp
	DialogHandler.cpp
	DialogMgr.cpp
	DisplayMessage.cpp
	EffectMgr.cpp
	EffectQueue.cpp
	Factory.cpp
	FactoryObject.cpp
	FileCache.cpp
	Font.cpp
	FontManager.cpp
	Game.cpp
	GameData.cpp
	GlobalTimer.cpp
	Image.cpp
	ImageFactory.cpp
	ImageMgr.cpp
	ImageWriter.cpp
	IndexedArchive.cpp
	IniSpawn.cpp
	Interface.cpp
	Inventory.cpp
	Item.cpp
	ItemMgr.cpp
	KeyMap.cpp
	LRUCache.cpp
	Map.cpp
	MapMgr.cpp
	MoviePlayer.cpp
	MusicMgr.cpp
	Palette.cpp
	PalettedImageMgr.cpp
	Particles.cpp
	Plugin.cpp
	PluginLoader.cpp
	PluginMgr.cpp
	Polygon.cpp
	Projectile.cpp
	ProjectileMgr.cpp
	ProjectileServer.cpp
	Region.cpp
	Resource.cpp
	ResourceDesc.cpp
	ResourceManager.cpp
	ResourceSource.cpp
	SaveGameIterator.cpp
	SaveGameMgr.cpp
	ScriptEngine.cpp
	ScriptedAnimation.cpp
	SoundMgr.cpp
	Spell.cpp
	SpellMgr.cpp
	Spellbook.cpp
	Sprite2D.cpp
	SpriteCover.cpp
	Store.cpp
	StoreMgr.cpp
	StringMgr.cpp
	SymbolMgr.cpp
	TableMgr.cpp
	Tile.cpp
	TileMap.cpp
	TileMapMgr.cpp
	TileOverlay.cpp
	TileSetMgr.cpp
	Variables.cpp
	Video.cpp
	WindowMgr.cpp
	WorldMap.cpp
	WorldMapMgr.cpp
	GameScript/Actions.cpp
	GameScript/GSUtils.cpp
	GameScript/GameScript.cpp
	GameScript/Matching.cpp
	GameScript/Objects.cpp
	GameScript/Triggers.cpp
	GUI/Button.cpp
	GUI/Console.cpp
	GUI/Control.cpp
	GUI/EventMgr.cpp
	GUI/GameControl.cpp
	GUI/Label.cpp
	GUI/MapControl.cpp
	GUI/Progressbar.cpp
	GUI/ScrollBar.cpp
	GUI/Slider.cpp
	GUI/TextArea.cpp
	GUI/TextEdit.cpp
	GUI/Window.cpp
	GUI/WorldMapControl.cpp
	Scriptable/Actor.cpp
	Scriptable/Container.cpp
	Scriptable/Door.cpp
	Scriptable/InfoPoint.cpp
	Scriptable/Scriptable.cpp
	Scriptable/PCStatStruct.cpp
	System/DataStream.cpp
	System/FileStream.cpp
	System/MemoryStream.cpp
	System/StringBuffer.cpp
	System/Logger.cpp
	System/Logger/File.cpp
	System/Logger/Stdio.cpp
	System/Logging.cpp
	System/SlicedStream.cpp
	System/String.cpp
	System/StringBuffer.cpp
	System/VFS.cpp
	${PLATFORM_SRC}
	)

if (STATIC_LINK)
	ADD_LIBRARY(gemrb_core STATIC ${gemrb_core_LIB_SRCS})
else (STATIC_LINK)
	ADD_LIBRARY(gemrb_core SHARED ${gemrb_core_LIB_SRCS})
	IF(WIN32)
	  INSTALL(TARGETS gemrb_core RUNTIME DESTINATION ${LIB_DIR})
	ELSE(WIN32)
	  INSTALL(TARGETS gemrb_core LIBRARY DESTINATION ${LIB_DIR})
	ENDIF(WIN32)
endif (STATIC_LINK)

SET_TARGET_PROPERTIES(gemrb_core PROPERTIES
	COMPILE_DEFINITIONS
	"PLUGINDIR=\"${PLUGIN_DIR}\";DATADIR=\"${DATA_DIR}\";SYSCONFDIR=\"${SYSCONF_DIR}\""
	)

IF (APPLE)
	SET_TARGET_PROPERTIES(gemrb_core PROPERTIES
	INSTALL_NAME_DIR ${LIB_DIR})
ENDIF (APPLE)

=== gemrb/GUIScripts/iwd2/CMakeLists.txt ===
FILE( GLOB FILES_TO_INSTALL *.py )

INSTALL( FILES ${FILES_TO_INSTALL} DESTINATION ${DATA_DIR}/GUIScripts/iwd2 )

=== gemrb/plugins/BAMImporter/CMakeLists.txt ===
ADD_GEMRB_PLUGIN (BAMImporter BAMImporter.cpp BAMFontManager)

=== debian/changelog ===
gemrb (0.7.1maemo1) unstable; urgency=low
  New features
    -almost all iwd2 feats
    -encumbrance penalties in movement
    -configurable xp/damage adjustments per difficulty level
    -support for logging to file directly
    -iwd2 armor penalty and critical hit multiplier
    -beginnings of iwd2 spellbook support
    -vlc plugin for extra video formats
  Improved features
    -(iwd2) effects, actions, combat, action bar, infravision
    -sdl renderer and an initial sdl2 port
    -config loading, logging
    -cocoa wrapper and mac build, cursor handling, touch input
    -bugfixes

  More info: http://www.gemrb.org/
 -- Nerdknight <nerdknight@gmail.com>  Fri, 27 Jul 2012 15:43:41 -0300

## gemrb 0.7.2maemo1

=== CMakeLists.txt ===
--- 
+++ 
@@ -76,6 +76,7 @@
 	SET_PATH( ICON_DIR ${CMAKE_INSTALL_PREFIX} )
 	SET_PATH( SVG_DIR ${CMAKE_INSTALL_PREFIX} )
 	SET_PATH( MENU_DIR ${CMAKE_INSTALL_PREFIX} )
+	SET_PATH( EXAMPLE_CONF_DIR ${CMAKE_INSTALL_PREFIX} )
 elseif (${LAYOUT} MATCHES "fhs")
 	SET_PATH( LIB_DIR ${CMAKE_INSTALL_PREFIX}/lib/gemrb )
 	SET_PATH( PLUGIN_DIR ${LIB_DIR}/plugins )
@@ -93,6 +94,7 @@
 	SET_PATH( ICON_DIR ${CMAKE_INSTALL_PREFIX}/share/pixmaps )
 	SET_PATH( SVG_DIR ${CMAKE_INSTALL_PREFIX}/share/icons/hicolor/scalable/apps )
 	SET_PATH( MENU_DIR ${CMAKE_INSTALL_PREFIX}/share/applications )
+	SET_PATH( EXAMPLE_CONF_DIR ${SYSCONF_DIR} )
 elseif (${LAYOUT} MATCHES "opt")
 	SET_PATH( LIB_DIR ${CMAKE_INSTALL_PREFIX}/lib )
 	SET_PATH( PLUGIN_DIR ${LIB_DIR}/plugins )
@@ -104,6 +106,7 @@
 	SET_PATH( ICON_DIR ${CMAKE_INSTALL_PREFIX}/share/pixmaps )
 	SET_PATH( SVG_DIR ${CMAKE_INSTALL_PREFIX}/share/icons/hicolor/scalable/apps )
 	SET_PATH( MENU_DIR ${CMAKE_INSTALL_PREFIX}/share/applications )
+	SET_PATH( EXAMPLE_CONF_DIR ${SYSCONF_DIR} )
 else (${LAYOUT} MATCHES "library") # mac
 	SET_PATH( APPLICATION_SUPPORT $ENV{HOME}/Library/Application\ Support/GemRB)
 	SET_PATH( LIB_DIR ${APPLICATION_SUPPORT}) #should go in app bundle!
@@ -116,6 +119,7 @@
 	SET_PATH( ICON_DIR ${APPLICATION_SUPPORT}/share/pixmaps )
 	SET_PATH( SVG_DIR ${APPLICATION_SUPPORT}/share/icons/hicolor/scalable/apps )
 	SET_PATH( MENU_DIR ${APPLICATION_SUPPORT}/share/applications )
+	SET_PATH( EXAMPLE_CONF_DIR ${SYSCONF_DIR} )
 endif (${LAYOUT} MATCHES "home")
 
 # check if this is a release version
@@ -133,7 +137,7 @@
 
 IF(CMAKE_CXX_COMPILER_ID MATCHES "GNU|Clang")
 	if ((NOT DISABLE_WERROR) AND GIT_VERSION)
-		set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Werror")
+		set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Werror -Wno-error=cast-align")
 	endif ()
 	set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wall -W -Wpointer-arith -Wcast-align")
 	set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -pedantic -Wno-format-y2k -Wno-long-long -fno-strict-aliasing")
@@ -157,7 +161,11 @@
 set(CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} "${CMAKE_CURRENT_SOURCE_DIR}/cmake/modules/")
 
 # Check for all the required and optional dependencies
-INCLUDE(FindPythonLibs)
+IF((CMAKE_MAJOR_VERSION GREATER 1) AND (CMAKE_MINOR_VERSION GREATER 7))
+	FIND_PACKAGE(PythonLibs 2.3 REQUIRED)
+ELSE((CMAKE_MAJOR_VERSION GREATER 1) AND (CMAKE_MINOR_VERSION GREATER 7))
+	INCLUDE(FindPythonLibs)
+ENDIF((CMAKE_MAJOR_VERSION GREATER 1) AND (CMAKE_MINOR_VERSION GREATER 7))
 IF(PYTHONLIBS_FOUND)
 	MESSAGE(STATUS "Looking for Python libraries and headers: found")
 ELSE()
@@ -211,12 +219,12 @@
 	MESSAGE(WARNING "If you want to build the VLC plugin, install VLC first.")
 ENDIF()
 
-INCLUDE(FindSDL_ttf)
-IF(SDLTTF_FOUND)
-	MESSAGE(STATUS "Looking for SDL_ttf: found")
-ELSE()
-	MESSAGE(WARNING "Looking for SDL_ttf: not found!")
-	MESSAGE(WARNING "If you want to build the SDL_ttf plugin, install SDL_ttf first.")
+INCLUDE(FindFreetype)
+IF(FREETYPE_FOUND)
+	MESSAGE(STATUS "Looking for Freetype: found")
+ELSE()
+	MESSAGE(WARNING "Looking for Freetype: not found!")
+	MESSAGE(WARNING "If you want to build the TTF plugin, install Freetype first.")
 ENDIF()
 
 INCLUDE(FindPNG)
@@ -323,19 +331,10 @@
 		endif (APPLE)
 	endif (${ARGV1} STREQUAL "COCOA")
 
-        if (STATIC_LINK)
-                ADD_LIBRARY(${plugin_name} STATIC ${PLUGIN_BUILD_FILES})
-                set(plugins "${plugins};${plugin_name}" PARENT_SCOPE)
-        else (STATIC_LINK)
-                ADD_LIBRARY(${plugin_name} MODULE ${PLUGIN_BUILD_FILES})
-                if (NOT UNSAFE_PLUGIN)
-                        TARGET_LINK_LIBRARIES(${plugin_name} gemrb_core ${CMAKE_THREAD_LIBS_INIT})
-                endif (NOT UNSAFE_PLUGIN)
-                INSTALL(TARGETS ${plugin_name} DESTINATION ${PLUGIN_DIR})
-        endif (STATIC_LINK)
-        SET_TARGET_PROPERTIES(${plugin_name} PROPERTIES PREFIX ""
-                INSTALL_RPATH ${LIB_DIR}
-                LIBRARY_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR}/gemrb/plugins)
-ENDMACRO(ADD_GEMRB_PLUGIN)
-
-#gemrb overrides macro
+	if (STATIC_LINK)
+		ADD_LIBRARY(${plugin_name} STATIC ${PLUGIN_BUILD_FILES})
+		set(plugins "${plugins};${plugin_name}" PARENT_SCOPE)
+	else (STATIC_LINK)
+		ADD_LIBRARY(${plugin_name} MODULE ${PLUGIN_BUILD_FILES})
+		if (NOT UNSAFE_PLUGIN)
+			TARGET_LINK_LIBRARIES(${plugin_name} gemrb_core ${CMAKE_THREAD_LIBS_INIT})

=== gemrb/CMakeLists.txt ===
--- 
+++ 
@@ -8,7 +8,7 @@
 	SET(MACOSX_BUNDLE_ICON_FILE gemrb)
 	ADD_EXECUTABLE(gemrb MACOSX_BUNDLE ../apple/CocoaWrapper/mac/CocoaWrapper.mm ../apple/AppleLogger.mm ../artwork/gemrb.icns)
 	SET (BUNDLE_LOADER "${CMAKE_CURRENT_BINARY_DIR}/${PROJECT_NAME}.app/Contents/MacOS/${PROJECT_NAME}") # BUNDLE_LOADER is used by plugins needing to extend the cocoa wrapper (SDLVideo).
-	SET(CMAKE_MODULE_LINKER_FLAGS "${CMAKE_MODULE_LINKER_FLAGS} -bundle_loader ${BUNDLE_LOADER}")
+	SET(CMAKE_MODULE_LINKER_FLAGS "${CMAKE_MODULE_LINKER_FLAGS} -bundle_loader \"${BUNDLE_LOADER}\"")
 ELSE(APPLE)
 	ADD_EXECUTABLE(gemrb GemRB.cpp )
 ENDIF(APPLE)
@@ -19,7 +19,7 @@
 ADD_SUBDIRECTORY( tests )
 IF (APPLE)
 	# GUIScripts ALWAYS get copied to the App bundle
-	SET( DATA_DIR ${BIN_DIR}/${PROJECT_NAME}.app/Contents/Resources/ )
+	SET( DATA_DIR "${BIN_DIR}/${PROJECT_NAME}.app/Contents/Resources/" )
 ENDIF(APPLE)
 ADD_SUBDIRECTORY( override )
 ADD_SUBDIRECTORY( GUIScripts )
@@ -56,4 +56,4 @@
 )
 
 INSTALL( TARGETS gemrb DESTINATION ${BIN_DIR} )
-INSTALL( FILES "${CMAKE_CURRENT_BINARY_DIR}/GemRB.cfg.sample" GemRB.cfg.noinstall.sample DESTINATION ${SYSCONF_DIR} )
+INSTALL( FILES "${CMAKE_CURRENT_BINARY_DIR}/GemRB.cfg.sample" GemRB.cfg.noinstall.sample DESTINATION ${EXAMPLE_CONF_DIR} )

=== gemrb/core/CMakeLists.txt ===
--- 
+++ 
@@ -125,9 +125,9 @@
 	System/DataStream.cpp
 	System/FileStream.cpp
 	System/MemoryStream.cpp
-	System/StringBuffer.cpp
 	System/Logger.cpp
 	System/Logger/File.cpp
+	System/Logger/MessageWindowLogger.cpp
 	System/Logger/Stdio.cpp
 	System/Logging.cpp
 	System/SlicedStream.cpp
@@ -141,6 +141,7 @@
 	ADD_LIBRARY(gemrb_core STATIC ${gemrb_core_LIB_SRCS})
 else (STATIC_LINK)
 	ADD_LIBRARY(gemrb_core SHARED ${gemrb_core_LIB_SRCS})
+	TARGET_LINK_LIBRARIES(gemrb_core ${CMAKE_DL_LIBS})
 	IF(WIN32)
 	  INSTALL(TARGETS gemrb_core RUNTIME DESTINATION ${LIB_DIR})
 	ELSE(WIN32)

=== gemrb/override/CMakeLists.txt ===
ADD_SUBDIRECTORY( bg1 )
ADD_SUBDIRECTORY( bg2 )
ADD_SUBDIRECTORY( how )
ADD_SUBDIRECTORY( iwd )
ADD_SUBDIRECTORY( iwd2 )
ADD_SUBDIRECTORY( pst )
ADD_SUBDIRECTORY( shared )

=== gemrb/GUIScripts/bg2/CMakeLists.txt ===
FILE( GLOB FILES_TO_INSTALL *.py )

INSTALL( FILES ${FILES_TO_INSTALL} DESTINATION ${DATA_DIR}/GUIScripts/bg2 )

=== gemrb/GUIScripts/pst/CMakeLists.txt ===
FILE( GLOB FILES_TO_INSTALL *.py )

INSTALL( FILES ${FILES_TO_INSTALL} DESTINATION ${DATA_DIR}/GUIScripts/pst )

=== gemrb/override/bg1/CMakeLists.txt ===
ADD_GEMRB_OVERRIDE (bg1)

=== gemrb/override/shared/CMakeLists.txt ===
ADD_GEMRB_OVERRIDE (shared)

=== gemrb/plugins/SDLVideo/CMakeLists.txt ===
INCLUDE_DIRECTORIES( ${SDL_INCLUDE_DIR} )

ADD_GEMRB_PLUGIN (SDLVideo COCOA SDLVideo.cpp SDL12Video.cpp)
TARGET_LINK_LIBRARIES( SDLVideo ${SDL_LIBRARY} ${CMAKE_THREAD_LIBS_INIT} ${COCOA_LIBRARY_PATH})

=== gemrb/plugins/TTFImporter/CMakeLists.txt ===
IF (FREETYPE_LIBRARY)
	INCLUDE_DIRECTORIES( ${FREETYPE_INCLUDE_DIRS})

	ADD_GEMRB_PLUGIN (TTFImporter TTFFontManager.cpp )
	TARGET_LINK_LIBRARIES( TTFImporter ${FREETYPE_LIBRARY} )
ENDIF (FREETYPE_LIBRARY)

=== debian/changelog ===
gemrb (0.7.2maemo1) unstable; urgency=low
  New features
    -configuration changes are now saved to gem-baldur.ini (or equivalent)
    -GemRB now asks for confirmation when exiting
    -output can now be shown in the ingame message window (run debug(5))
    -ToBEx flags for effect damage: bypass mirror image, ignore difficulty
    -SDL2 software keyboard
  Improved features
    -custom dialog.tlk encoding support
    -fonts, effect icons, initials, chapter text
    -option windows
    -actions, triggers, effects, invisibility handling
    -assorted bugfixes

  More info: http://www.gemrb.org/
 -- Nerdknight <nerdknight@gmail.com>  Thu, 24 Jan 2013 12:23:00 -0300

=== debian/control ===
Source: gemrb
Section: user/games
Priority: extra
Maintainer: Nerdknight <nerdknight@gmail.com>
Build-Depends: debhelper (>= 5), cmake, libopenal-dev, python-support, python2.5-dev, libpng12-dev, libvorbis-dev, libsdl1.2-dev, zlib1g-dev,libsdl-ttf2.0-dev
Standards-Version: 3.7.2
Homepage: http://gemrb.sourceforge.net

Package: gemrb
Architecture: armel
Depends: ${shlibs:Depends}, ${misc:Depends}
Description:  GemRB is an open-source implementation of Bioware's Infinity Engine.
 GemRB (Game engine made with preRendered Background) is a portable 
 open-source implementation of Bioware's Infinity Engine.
 .
 You need to own the original games in order to play them.
 .
 Version 0.7.1 changes:
 New features
    -almost all iwd2 feats
    -encumbrance penalties in movement
    -configurable xp/damage adjustments per difficulty level
    -support for logging to file directly
    -iwd2 armor penalty and critical hit multiplier
    -beginnings of iwd2 spellbook support
    -vlc plugin for extra video formats
 Improved features
    -(iwd2) effects, actions, combat, action bar, infravision
    -sdl renderer and an initial sdl2 port
    -config loading, logging
    -cocoa wrapper and mac build, cursor handling, touch input
    -bugfixes
XB-Maemo-Display-Name: GemRB
XSBC-Bugtracker: http://talk.maemo.org/showthread.php?p=1153973
XB-Maemo-Icon-26:
 iVBORw0KGgoAAAANSUhEUgAAAEAAAABACAYAAACqaXHeAAAABHNCSVQICAgI
 fAhkiAAAAAlwSFlzAAAEdgAABHYBvT2qxwAAABl0RVh0U29mdHdhcmUAd3d3
 Lmlua3NjYXBlLm9yZ5vuPBoAAAYISURBVHja7Zt7UFRVHMeBFZCHsLDBiqDM
 iiGLiBQpCEyCOMVDcQER8sEoVkzAENMQYsIoFaZlDsxgQgyaKWM2zTRN03um
 VLRySkfTprQxUAsNexhigoG/fme9S8ty755zl717BfY38/mDmd17ft/P7t57
 7jkXBwBwkAOsIsRbrvEH+5ApfD5yB1GOOwFYy5B+BMadAKw05DYXfnwJwEpE
 bhmFHz8CsGKRGybhx4cArDnIXzzhx74ArDCkSyD82BaApUF+MRN+zAvYTAlv
 F2AXYBdgF2AXYBdgF2AXYBdgFzDaBWC5IpFICrIOqUa+ZhCwG2kUQR1SgaxE
 kpCpsgnAckOykFbkb4awUnGKEz7LJgKw1EgT0iNjaCGOI3GSCOC+5pVI9z0Y
 3BTyrQyymgCsBOTnURDcGPIN1Y1YAFYe0jvKwhsYQMosFoC1gdvAgFFOPeIo
 SgDWtjEQ3JjnmAVg5Y6x8IafQwpVALmeWniJIwMcQZqRGuQj2ns0gdUwI7CR
 Gc2UHRCgKgafSSngPCHAEgl/IiGCArAmIedFHvQnbqd3stipcFZqOzykPQ8J
 kSAajd9JUHu+C27OiWIlfGJOwPMiDkTmA88iLpbeC6zMvA456V0wV9suKnxc
 xE3QqPpgui/oCZj0OSgc/cRISBgmAMtXxCSHzAm0I70ZIgLWLgdYltYJ87SX
 mQVEhpwYDG9gmrIDXBRRrAIO8Ql4ifHNJxB/a9wNGgQQdI9chJjwq0wCQgO/
 GCaAoPHpAWeFllVC0qAALD/GE98VZIq1boeNBRAyki9A7KzfqQKm+53lFUAI
 8j4Njo4TWQQ0GwsoYnjDv0i8NdcDTAUQ0hf+iBKu8wbXLQIoXdcLMWH9ggII
 Kvd6FgGdZHJkaPZDhjc0WXtBhE8AIeXhMzA/ogcWxQAU4N816wH24Ohv779L
 cwNA9P3CAjS+t0HhpGaREE0aded5cMGUXrGLDyMRQFhfdgUO7vs/tCmNdQBR
 GmEJSrcNLAI2kUYzGF64R4olMXMCWl4TDm+g4VWA2cH8AqZ6nwMy/af08BZp
 dDuDAJ0tBTy5Csx++sbUbwOYFXQ3dLDPJZimOgwzg47jeaQHXJwDqZdD0ugB
 hq+/py0FVD7NFt5AeXEnRM0YPpny8oinCfjBgbNg7kUnpVoVFhKw/QVxAorX
 8F8u/ZQraALIozsO5ygv+sBCAZU0AblLfuUVsHuXOAFLF/ILmKwqpAkgJ3/q
 9LfFQgFraQLSk78cFv6p1XdEhX+jSXjCpPJaShNw0YHhBFhnoYBU2rETYw/o
 Q6/O/gPydMegYMVRqCq/BntfZxfw4kZhAZ7uc1lWkSUT8ADt2NFRpVBa+D3U
 Vg3AlmoYZOsmgDeb2QQUruYPPz+iG6fELrRs70kpwJ92bF+fEKitvjMkvIFt
 KGFfC11A+gJ+AWHB77BMhHZKJoCT8B3t+AWrPuMVoJdQA7B/N//v/hW8UlSU
 DEB02Fe8ApSeySwCsqQWsIV2fG1ohqAAwssooWXXTdi5A2BzJUBJwdCTZn52
 H0r4Zujt8tS9LOH7uBUwSQXEsdyb52a2mpWge7RNcMqsP4lm/YMSTunDx4R3
 wQSFikXAp1yPkgpwQq7SxnB19YLykguCApYvuWRWAGGF7gZKOMsy+TFQLLkA
 boBylobU/hFQUdoxLPwzRZep4QlrcvohcuZG1vC/IR62EuDGLT5QG/Nw94Mn
 8g8NEZCX2UYNn7O4A9T3JYhZFC0z6k9aAdwgxazNKZycIT6mbPAnoUs5ajb8
 gthWvOvzFhP+MtnptrUAF+SMmPV7R0cn/RVi/oP1kJp0WH/fkJ99C3LS2yEt
 6QjMCa8CpZfWks2Rx0x6k14AN1CozE+SEBp4+rKNAG6wTBnDH0OcZRXADVgj
 Q/gOJECgH9sK4AYt5TZTbRH+W9N9S9kFcAMvtsGDVu8brvf3nABu8Nnclrq1
 g3dzK1IKhh7kE2DURA7SbqWHIMjzCWoRY8svgGtkIvI48rHJv9eynuTI8n6E
 BePeGwJMmvJB1nCfJtm2O41c4xYxydZ8G3IQqUXmjWSs/wDHL4xdfg+anQAA
 AABJRU5ErkJggg==

## gemrb 0.8.0

=== CMakeLists.txt ===
--- 
+++ 
@@ -48,7 +48,7 @@
 	if (WIN32)
 		set(LAYOUT "home")
 	elseif (APPLE)
-		set(LAYOUT "library")
+		set(LAYOUT "bundle")
 		# favor mac frameworks over unix libraries
 		set(CMAKE_FIND_FRAMEWORK FIRST)
 	else (APPLE)
@@ -107,19 +107,13 @@
 	SET_PATH( SVG_DIR ${CMAKE_INSTALL_PREFIX}/share/icons/hicolor/scalable/apps )
 	SET_PATH( MENU_DIR ${CMAKE_INSTALL_PREFIX}/share/applications )
 	SET_PATH( EXAMPLE_CONF_DIR ${SYSCONF_DIR} )
-else (${LAYOUT} MATCHES "library") # mac
-	SET_PATH( APPLICATION_SUPPORT $ENV{HOME}/Library/Application\ Support/GemRB)
-	SET_PATH( LIB_DIR ${APPLICATION_SUPPORT}) #should go in app bundle!
-	SET_PATH( PLUGIN_DIR ${APPLICATION_SUPPORT}/plugins )
-	SET_PATH( DATA_DIR ${APPLICATION_SUPPORT} )
-	SET_PATH( MAN_DIR /usr/share/man/man6 )
+else (${LAYOUT} MATCHES "bundle") # Mac or iOS
+	# most paths are irrelevant since the items will be bundled with application
 	SET_PATH( BIN_DIR /Applications )
-	SET_PATH( SYSCONF_DIR ${APPLICATION_SUPPORT})
-	SET_PATH( DOC_DIR ${APPLICATION_SUPPORT} )
-	SET_PATH( ICON_DIR ${APPLICATION_SUPPORT}/share/pixmaps )
-	SET_PATH( SVG_DIR ${APPLICATION_SUPPORT}/share/icons/hicolor/scalable/apps )
-	SET_PATH( MENU_DIR ${APPLICATION_SUPPORT}/share/applications )
-	SET_PATH( EXAMPLE_CONF_DIR ${SYSCONF_DIR} )
+	# TODO: these should be copied during build and not install.
+	SET_PATH( LIB_DIR "${BIN_DIR}/${PROJECT_NAME}.app/Contents/Frameworks" )
+	SET_PATH( PLUGIN_DIR "${BIN_DIR}/${PROJECT_NAME}.app/Contents/Plugins" )
+	SET_PATH( DOC_DIR "${BIN_DIR}/${PROJECT_NAME}.app/Contents/Resources" )
 endif (${LAYOUT} MATCHES "home")
 
 # check if this is a release version
@@ -222,6 +216,12 @@
 INCLUDE(FindFreetype)
 IF(FREETYPE_FOUND)
 	MESSAGE(STATUS "Looking for Freetype: found")
+	INCLUDE(FindICONV)
+	IF(NOT ICONV_FOUND)
+		MESSAGE(WARNING "Iconv not found. TTF plugin will not be able to translate non-unicode compatible TLK encodings.")
+	ELSE()
+		set(HAVE_ICONV)
+	ENDIF()
 ELSE()
 	MESSAGE(WARNING "Looking for Freetype: not found!")
 	MESSAGE(WARNING "If you want to build the TTF plugin, install Freetype first.")
@@ -254,7 +254,8 @@
 
 # On Release builds cmake automatically defines NDEBUG, so we
 # explicitly undefine it:
-if(CMAKE_BUILD_TYPE STREQUAL "Release" AND NOT MSVC)
+# This matches stripped (Release) and nonstripped (RelWithDebInfo) builds
+if(CMAKE_BUILD_TYPE MATCHES "Rel.*" AND NOT MSVC)
 	ADD_DEFINITIONS("-UNDEBUG")
 endif()
 
@@ -276,6 +277,8 @@
 
 INCLUDE (CheckFunctionExists)
 CHECK_FUNCTION_EXISTS("strndup" HAVE_STRNDUP)
+CHECK_FUNCTION_EXISTS("strlcpy", HAVE_STRLCPY)
+CHECK_FUNCTION_EXISTS("setenv" HAVE_SETENV)
 
 CHECK_INCLUDE_FILES("unistd.h" HAVE_UNISTD_H)
 CHECK_INCLUDE_FILES("malloc.h" HAVE_MALLOC_H)
@@ -296,9 +299,17 @@
 ENDIF(NOT WIN32)
 
 IF(APPLE)
+	# Make sure we can find the 'ibtool' program. we need it to compile xibs
+	find_program(IBTOOL ibtool HINTS "/usr/bin" "${OSX_DEVELOPER_ROOT}/usr/bin")
+	IF (${IBTOOL} STREQUAL "IBTOOL-NOTFOUND")
+  		MESSAGE (FATAL_ERROR "ibtool can not be found and is needed to compile the .xib files. It should have been installed with 
+                    the Apple developer tools. The default system paths were searched in addition to ${OSX_DEVELOPER_ROOT}/usr/bin")
+	ENDIF ()
+
 	ADD_DEFINITIONS("-x objective-c++")
 	INCLUDE_DIRECTORIES(apple)
 	FIND_LIBRARY(COCOA_LIBRARY_PATH Cocoa)
+	FIND_LIBRARY(COREFOUNDATION_LIBRARY CoreFoundation)
 	# for objective-c++
 	SET (CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -DTARGET_OS_MAC")
 	# for pure objective-c
@@ -321,20 +332,3 @@
 	if (${ARGV1} STREQUAL "COCOA")
 		LIST(REMOVE_ITEM PLUGIN_BUILD_FILES "COCOA")
 		#this is an Apple thing
-		if (APPLE)
-			SET_SOURCE_FILES_PROPERTIES(
-				CocoaWrapper.m
-				PROPERTIES LANGUAGE C
-			)
-			message(STATUS "Will link ${plugin_name} plugin to: ${BUNDLE_LOADER}")
-			SET (PLUGIN_BUILD_FILES ${PLUGIN_BUILD_FILES} CocoaWrapper.m)
-		endif (APPLE)
-	endif (${ARGV1} STREQUAL "COCOA")
-
-	if (STATIC_LINK)
-		ADD_LIBRARY(${plugin_name} STATIC ${PLUGIN_BUILD_FILES})
-		set(plugins "${plugins};${plugin_name}" PARENT_SCOPE)
-	else (STATIC_LINK)
-		ADD_LIBRARY(${plugin_name} MODULE ${PLUGIN_BUILD_FILES})
-		if (NOT UNSAFE_PLUGIN)
-			TARGET_LINK_LIBRARIES(${plugin_name} gemrb_core ${CMAKE_THREAD_LIBS_INIT})

=== gemrb/CMakeLists.txt ===
--- 
+++ 
@@ -1,28 +1,67 @@
 ADD_SUBDIRECTORY( core )
 
-IF(APPLE)
+# GUIScripts and override go directly in the bundle
+SET(RESOURCE_LIST "GUIScripts" "override" "unhardcoded")
+SET(RESOURCE_FILES "")
+
+FOREACH(RESOURCE_DIR_NAME ${RESOURCE_LIST})
+	SET(RESOURCE_DIR "${CMAKE_CURRENT_SOURCE_DIR}/${RESOURCE_DIR_NAME}")
+	IF (APPLE)
+		FILE(GLOB CHILDREN RELATIVE "${RESOURCE_DIR}" ${RESOURCE_DIR}/*)
+		FOREACH(CHILD ${CHILDREN})
+			IF(IS_DIRECTORY "${RESOURCE_DIR}/${CHILD}")
+				# be wary of .DS_Store files. glob them out by using [A-Za-z]*.*
+				FILE(GLOB RESOURCE_DIR_FILES RELATIVE "${CMAKE_CURRENT_SOURCE_DIR}" "${RESOURCE_DIR}/${CHILD}/[A-Za-z]*.*")
+				SET_SOURCE_FILES_PROPERTIES(
+					${RESOURCE_DIR_FILES}
+					PROPERTIES MACOSX_PACKAGE_LOCATION Resources/${RESOURCE_DIR_NAME}/${CHILD}
+				)
+				SET(RESOURCE_FILES ${RESOURCE_FILES} ${RESOURCE_DIR_FILES})
+			ELSE()
+				IF (NOT ${CHILD} MATCHES "\\.DS_Store|.*\\.am")
+					SET_SOURCE_FILES_PROPERTIES(
+						"${RESOURCE_DIR}/${CHILD}"
+						PROPERTIES MACOSX_PACKAGE_LOCATION Resources/${RESOURCE_DIR_NAME}
+					)
+					SET(RESOURCE_FILES ${RESOURCE_FILES} "${RESOURCE_DIR_NAME}/${CHILD}")
+				ENDIF()
+			ENDIF()
+		ENDFOREACH()
+	ELSE (APPLE)
+		INSTALL( DIRECTORY ${RESOURCE_DIR} DESTINATION "${DATA_DIR}" PATTERN "*.am" EXCLUDE)
+	ENDIF (APPLE)
+ENDFOREACH()
+
+IF(APPLE) #application bundle generation
+	# icon
 	SET_SOURCE_FILES_PROPERTIES(
 		../artwork/gemrb.icns
 		PROPERTIES MACOSX_PACKAGE_LOCATION Resources
 	)
+
+	# default values
+	SET_SOURCE_FILES_PROPERTIES(
+		../apple/defaults.plist
+		PROPERTIES MACOSX_PACKAGE_LOCATION Resources
+	)
+
 	SET(MACOSX_BUNDLE_ICON_FILE gemrb)
-	ADD_EXECUTABLE(gemrb MACOSX_BUNDLE ../apple/CocoaWrapper/mac/CocoaWrapper.mm ../apple/AppleLogger.mm ../artwork/gemrb.icns)
+	ADD_EXECUTABLE(gemrb MACOSX_BUNDLE ../apple/CocoaWrapper/mac/CocoaWrapper.mm ../apple/AppleLogger.mm
+					../artwork/gemrb.icns ../apple/defaults.plist
+					${RESOURCE_FILES})
 	SET (BUNDLE_LOADER "${CMAKE_CURRENT_BINARY_DIR}/${PROJECT_NAME}.app/Contents/MacOS/${PROJECT_NAME}") # BUNDLE_LOADER is used by plugins needing to extend the cocoa wrapper (SDLVideo).
 	SET(CMAKE_MODULE_LINKER_FLAGS "${CMAKE_MODULE_LINKER_FLAGS} -bundle_loader \"${BUNDLE_LOADER}\"")
 ELSE(APPLE)
+	ADD_SUBDIRECTORY( docs )
+	ADD_SUBDIRECTORY( tests )
+
 	ADD_EXECUTABLE(gemrb GemRB.cpp )
+
+	INSTALL( FILES "${CMAKE_CURRENT_BINARY_DIR}/GemRB.cfg.sample" GemRB.cfg.noinstall.sample DESTINATION ${EXAMPLE_CONF_DIR} )
 ENDIF(APPLE)
+
 # we need to add gemrb target before processing plugins or COCOA plugins don't work right.
-
 ADD_SUBDIRECTORY( plugins )
-ADD_SUBDIRECTORY( docs )
-ADD_SUBDIRECTORY( tests )
-IF (APPLE)
-	# GUIScripts ALWAYS get copied to the App bundle
-	SET( DATA_DIR "${BIN_DIR}/${PROJECT_NAME}.app/Contents/Resources/" )
-ENDIF(APPLE)
-ADD_SUBDIRECTORY( override )
-ADD_SUBDIRECTORY( GUIScripts )
 
 SET_TARGET_PROPERTIES(gemrb PROPERTIES INSTALL_RPATH ${LIB_DIR})
 INCLUDE_DIRECTORIES( ${SDL_INCLUDE_DIR} )
@@ -30,6 +69,16 @@
  TARGET_LINK_LIBRARIES(gemrb gemrb_core)
 ELSE(WIN32)
  IF(APPLE)
+	# custom info.plist
+	SET_TARGET_PROPERTIES(gemrb PROPERTIES MACOSX_BUNDLE_INFO_PLIST ../../apple/osx/Info.plist)
+
+	# compile nib
+	ADD_CUSTOM_COMMAND (TARGET gemrb POST_BUILD 
+                      COMMAND ${IBTOOL} --errors --warnings --notices --output-format human-readable-text 
+                              --compile ${CMAKE_CURRENT_BINARY_DIR}/${PROJECT_NAME}.app/Contents/Resources/GemRB.nib 
+                            ../../apple/CocoaWrapper/mac/nibs/GemRB.xib
+                      COMMENT "Compiling GemRB.xib")
+
 	if (STATIC_LINK)
 		TARGET_LINK_LIBRARIES(gemrb
 			  ${COCOA_LIBRARY_PATH} ${CMAKE_DL_LIBS} ${CMAKE_THREAD_LIBS_INIT}
@@ -56,4 +105,3 @@
 )
 
 INSTALL( TARGETS gemrb DESTINATION ${BIN_DIR} )
-INSTALL( FILES "${CMAKE_CURRENT_BINARY_DIR}/GemRB.cfg.sample" GemRB.cfg.noinstall.sample DESTINATION ${EXAMPLE_CONF_DIR} )

=== gemrb/plugins/BAMImporter/CMakeLists.txt ===
ADD_GEMRB_PLUGIN (BAMImporter BAMImporter.cpp BAMFontManager BAMFont.cpp)

=== debian/changelog ===
gemrb (0.8.0-1) unstable; urgency=low

  * First packaging for Debian (Closes: #658887)

 -- Beren Minor <beren.minor+debian@gmail.com>  Tue, 03 Sep 2013 20:50:57 +0200

=== debian/control ===
Source: gemrb
Section: contrib/games
Priority: optional
Maintainer: Beren Minor <beren.minor+debian@gmail.com>
Build-Depends: debhelper (>= 9), cmake, python-dev, libsdl1.2-dev,
 libsdl-ttf2.0-dev, libsdl-mixer1.2-dev, libz-dev, libopenal-dev, libpng-dev,
 libogg-dev, libvorbis-dev, libvlc-dev, libvlccore-dev
Standards-Version: 3.9.4
Homepage: http://www.gemrb.org/
Vcs-Git: git://anonscm.debian.org/pkg-games/gemrb.git
Vcs-Browser: http://anonscm.debian.org/gitweb/?p=pkg-games/gemrb.git

Package: gemrb
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, python-support (>= 0.90), gemrb-data (=${source:Version}), libgemrb (=${binary:Version})
Description: Open-source engine to run Baldur's Gate, Icewind Dale and Planescape: Torment
 GemRB (Game Engine Made with preRendered Background) is a new implementation
 of the original Infinity Engine (the one of Baldur's Gate, Icewind Dale,
 Planescape: Torment, ...) to Linux/Unix, MacOS X and Windows with some
 enhancements.
 .
 It means that you either need some of the original game's data
 somewhere on your harddisk, or you can try to use the data from the
 Dragonlance Total Conversion project.
 .
 The original game data has to be installed on a windows
 partition and mounted to your Linux/Unix filesystem, installed on
 windows and then copied to your filesystem, installed with WINE or
 extracted manually from the CDs using the tool `unshield'.
 .
 Supported games: Baldur's Gate and Icewind Dale series, Planescape:Torment.

Package: libgemrb
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Shared libraries and plugins for GemRB
 GemRB (Game Engine Made with preRendered Background) is a new implementation
 of the original Infinity Engine (the one of Baldur's Gate, Icewind Dale,
 Planescape: Torment, ...) to Linux/Unix, MacOS X and Windows with some
 enhancements.
 .
 This package contains GemRB core shared libraries and plugins.


Package: gemrb-doc
Section: contrib/doc
Architecture: all
Depends: ${misc:Depends}
Description: Documentation for GemRB
 GemRB (Game Engine Made with preRendered Background) is a new implementation
 of the original Infinity Engine (the one of Baldur's Gate, Icewind Dale,
 Planescape: Torment, ...) to Linux/Unix, MacOS X and Windows with some
 enhancements.
 .
 This package contains documentation about GemRB and how to write custom games.

Package: gemrb-data
Architecture: all
Depends: ${misc:Depends}
Description: Common data files for GemRB
 GemRB (Game Engine Made with preRendered Background) is a new implementation
 of the original Infinity Engine (the one of Baldur's Gate, Icewind Dale,
 Planescape: Torment, ...) to Linux/Unix, MacOS X and Windows with some
 enhancements.
 .
 This package contains data files used across all supported games.


Package: gemrb-baldurs-gate-data
Architecture: all
Depends: ${misc:Depends}, gemrb-data (=${source:Version})
Description: GemRB data files for Baldur's Gate game
 GemRB (Game Engine Made with preRendered Background) is a new implementation
 of the original Infinity Engine (the one of Baldur's Gate, Icewind Dale,
 Planescape: Torment, ...) to Linux/Unix, MacOS X and Windows with some
 enhancements.
 .
 This package contains data files for Baldur's Gate game.

Package: gemrb-baldurs-gate
Architecture: any
Depends: ${misc:Depends}, gemrb (=${binary:Version}), gemrb-baldurs-gate-data (=${source:Version})
Description: GemRB binary and configuration for Baldur's Gate game
 GemRB (Game Engine Made with preRendered Background) is a new implementation
 of the original Infinity Engine (the one of Baldur's Gate, Icewind Dale,
 Planescape: Torment, ...) to Linux/Unix, MacOS X and Windows with some
 enhancements.
 .
 This package contains configuration sample and binary for Baldur's Gate game.


Package: gemrb-baldurs-gate-2-data
Architecture: all
Depends: ${misc:Depends}, gemrb-data (=${source:Version})
Description: GemRB data files for Baldur's Gate 2 game
 GemRB (Game Engine Made with preRendered Background) is a new implementation
 of the original Infinity Engine (the one of Baldur's Gate, Icewind Dale,
 Planescape: Torment, ...) to Linux/Unix, MacOS X and Windows with some
 enhancements.
 .
 This package contains data files for Baldur's Gate 2 game.

Package: gemrb-baldurs-gate-2
Architecture: any
Depends: ${misc:Depends}, gemrb (=${binary:Version}), gemrb-baldurs-gate-2-data (=${source:Version})
Description: GemRB binary and configuration for Baldur's Gate 2 game
 GemRB (Game Engine Made with preRendered Background) is a new implementation
 of the original Infinity Engine (the one of Baldur's Gate, Icewind Dale,
 Planescape: Torment, ...) to Linux/Unix, MacOS X and Windows with some
 enhancements.
 .
 This package contains configuration sample and binary for Baldur's Gate 2 game.


Package: gemrb-icewind-dale-data
Architecture: all
Depends: ${misc:Depends}, gemrb-data (=${source:Version})
Description: GemRB data files for Icewind Dale game
 GemRB (Game Engine Made with preRendered Background) is a new implementation
 of the original Infinity Engine (the one of Baldur's Gate, Icewind Dale,
 Planescape: Torment, ...) to Linux/Unix, MacOS X and Windows with some
 enhancements.
 .
 This package contains data files for Icewind Dale game.

Package: gemrb-icewind-dale
Architecture: any
Depends: ${misc:Depends}, gemrb (=${binary:Version}), gemrb-icewind-dale-data (=${source:Version})
Description: GemRB binary and configuration for Icewind Dale game
 GemRB (Game Engine Made with preRendered Background) is a new implementation
 of the original Infinity Engine (the one of Baldur's Gate, Icewind Dale,
 Planescape: Torment, ...) to Linux/Unix, MacOS X and Windows with some
 enhancements.
 .
 This package contains configuration sample and binary for Icewind Dale game.


Package: gemrb-icewind-dale-2-data
Architecture: all
Depends: ${misc:Depends}, gemrb-data (=${source:Version})
Description: GemRB data files for Icewind Dale 2 game
 GemRB (Game Engine Made with preRendered Background) is a new implementation
 of the original Infinity Engine (the one of Baldur's Gate, Icewind Dale,
 Planescape: Torment, ...) to Linux/Unix, MacOS X and Windows with some
 enhancements.
 .
 This package contains data files for Icewind Dale 2 game.

Package: gemrb-icewind-dale-2
Architecture: any
Depends: ${misc:Depends}, gemrb (=${binary:Version}), gemrb-icewind-dale-2-data (=${source:Version})
Description: GemRB binary and configuration for Icewind Dale 2 game
 GemRB (Game Engine Made with preRendered Background) is a new implementation
 of the original Infinity Engine (the one of Baldur's Gate, Icewind Dale,
 Planescape: Torment, ...) to Linux/Unix, MacOS X and Windows with some
 enhancements.
 .
 This package contains configuration sample and binary for Icewind Dale 2 game.


Package: gemrb-planescape-torment-data
Architecture: all
Depends: ${misc:Depends}, gemrb-data (=${source:Version})
Description: GemRB data files for Planescape: Torment game
 GemRB (Game Engine Made with preRendered Background) is a new implementation
 of the original Infinity Engine (the one of Baldur's Gate, Icewind Dale,
 Planescape: Torment, ...) to Linux/Unix, MacOS X and Windows with some
 enhancements.
 .
 This package contains data files for Planescape: Torment game.

Package: gemrb-planescape-torment
Architecture: any
Depends: ${misc:Depends}, gemrb (=${binary:Version}), gemrb-planescape-torment-data (=${source:Version})
Description: GemRB binary and configuration for Planescape: Torment game
 GemRB (Game Engine Made with preRendered Background) is a new implementation
 of the original Infinity Engine (the one of Baldur's Gate, Icewind Dale,
 Planescape: Torment, ...) to Linux/Unix, MacOS X and Windows with some
 enhancements.
 .
 This package contains configuration sample and binary for Planescape: Torment
 game.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

%:
	dh $@ --with python2

override_dh_makeshlibs:
	dh_makeshlibs -n

## gemrb 0.8.0maemo1

=== debian/changelog ===
gemrb (0.8.0maemo1) unstable; urgency=low
  New features
    -iwd2: Chapter 0+1 completable, full spellbook and ECL support
    -multibyte font support (chinese, korean, japanese)
    -favourite weapon/spell tracking, bg1 dreams
    -most gemrb overrides were moved and are now moddable via game override
    -initial bundled gemrb demo stubs

  Improved features
    -random encounters and spawns (properly difficult)
    -iwd2 combat, stats, spells, skills, effects and actions
    -animations, speech, input
    -looting, worldmap, hotkeys (work everywhere), fatigue
    -bugfixes

  More info: http://www.gemrb.org/
 -- Nerdknight <nerdknight@gmail.com>  Wed, 8 May 2013 20:22:00 -0300
